<?php

$className = 'RBSPayment';
$paymentName = 'Оплата картой банка (RBSPayment)';

include 'standalone.php';

$objectTypesCollection = umiObjectTypesCollection::getInstance();
$internalTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-paymenttype');

$sel = new selector('objects');
$sel->types('object-type')->id($internalTypeId);
$sel->where('class_name')->equals($className);
$sel->limit(0, 1);

$bAdd = $sel->length() == 0;

$fieldTypesCollection = umiFieldTypesCollection::getInstance();
$typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean');
$typeString = $fieldTypesCollection->getFieldTypeByDataType('string');
$typeInt = $fieldTypesCollection->getFieldTypeByDataType('int');

if ($bAdd) {
    $objectsCollection = umiObjectsCollection::getInstance();

    $parentTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-payment');

    $typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);

    $objectType = $objectTypesCollection->getType($typeId);

    $groupdId = $objectType->addFieldsGroup('settings', 'Параметры', true, true);
    $group = $objectType->getFieldsGroupByName('settings');

    $fieldsCollection = umiFieldsCollection::getInstance();

    $fieldTypesCollection = umiFieldTypesCollection::getInstance();
    $typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
    $typeString = $fieldTypesCollection->getFieldTypeByDataType('string')->getId();
    $typeInt = $fieldTypesCollection->getFieldTypeByDataType('int')->getId();
    $typeSelect = $fieldTypesCollection->getFieldTypeByDataType('relation')->getId();

    $idRBSTestMode = $objectTypesCollection->addType(1, 'rbs-testMode');
    $idRBSTwoStage = $objectTypesCollection->addType(1, 'rbs-twoStage');
    $idRBSLogging = $objectTypesCollection->addType(1, 'rbs-logging');

    $idRBSTaxSystem = $objectTypesCollection->addType(1, 'rbs-taxType');
    $idRBSPaymentMethod = $objectTypesCollection->addType(1, 'rbs-paymentMethod');
    $idRBSPaymentObject = $objectTypesCollection->addType(1, 'rbs-paymentObject');

    $idRBSSendOrder = $objectTypesCollection->addType(1, 'rbs-sendOrder');
//    $idDeliveryTax = $objectTypesCollection->addType(1, 'rbs-taxType_delivery');

//    $optionTestMode = array(
//        '1' => 'Тестовый',
//        '2' => 'Боевой'
//    );
//    $optionTwoStage = array(
//        '1' => 'Одностадийные платежи',
//        '2' => 'Двухстадийные платежи'
//    );
//    $optionSendOrder = array(
//        '1' => 'Да',
//        '2' => 'Нет'
//    );

    $optionTaxType = array(
        '0' => 'Общая (0)',
        '1' => 'Упрощённая, доход (1)',
        '2' => 'Упрощённая, доход минус расход (2)',
        '3' => 'Eдиный налог на вменённый доход (3)',
        '4' => 'Eдиный сельскохозяйственный налог (4)',
        '5' => 'Патентная система налогообложения (5)',
    );
    $optionPaymentMethod = array(
        '1' => 'Полная предварительная оплата до момента передачи предмета расчёта (1)',
        '2' => 'Частичная предварительная оплата до момента передачи предмета расчёта (2)',
        '3' => 'Аванс (3)',
        '4' => 'Полная оплата в момент передачи предмета расчёта (4)',
        '5' => 'Частичная оплата предмета расчёта в момент его передачи с последующей оплатой в кредит (5)',
        '6' => 'Передача предмета расчёта без его оплаты в момент его передачи с последующей оплатой в кредит (6)',
        '7' => 'Оплата предмета расчёта после его передачи с оплатой в кредит (7)',
    );
    $optionPaymentObject = array(
        '1' => 'Товар (1)',
        '2' => 'Подакцизный товар (2)',
        '3' => 'Работа (3)',
        '4' => 'Услуга (4)',
        '5' => 'Ставка азартной игры (5)',
//                        '6' => 'Выигрыш азартной игры (6)',
        '7' => 'Лотерейный билет (7)',
//                        '8' => 'Выигрыш лотереи (8)',
        '9' => 'Предоставление РИД (9)',
        '10' => 'Платёж (10)',
        '11' => 'Агентское вознаграждение (11)',
        '12' => 'Составной предмет расчёта (12)',
        '13' => 'Иной предмет расчёта (13)',
    );
//    $optionLogging = array(
//        '1' => 'Вести логирование запросов в файл',
//        '2' => 'Не вести логирование запросов в файл',
//    );

    $objectsCollection = umiObjectsCollection::getInstance();


//    foreach ($optionTestMode as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSTestMode);
//    }
//    foreach ($optionTwoStage as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSTwoStage);
//    }
//    foreach ($optionSendOrder as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSSendOrder);
//    }
    foreach ($optionTaxType as $key => $value) {
        $objectsCollection->addObject($value, $idRBSTaxSystem);
    }
    foreach ($optionPaymentMethod as $key => $value) {
        $objectsCollection->addObject($value, $idRBSPaymentMethod);
    }
    foreach ($optionPaymentObject as $key => $value) {
        $objectsCollection->addObject($value, $idRBSPaymentObject);
    }
//    foreach ($optionLogging as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSLogging);
//    }

    $fields = array(
        'payment_type_id' => array(
            'name' => 'Метод оплаты',
            'type' => $typeSelect,
            'guide_id' => $internalTypeId,
            'required' => true,
        ),
        'rbspayment_user_name' => array(
            'name' => 'Логин',
            'tip' => 'Предоставляется банком',
            'type' => $typeString,
            'required' => true,
        ),
        'rbspayment_password' => array(
            'name' => 'Пароль',
            'tip' => 'Предоставляется банком',
            'type' => $typeString,
            'required' => true,
        ),
        'rbspayment_test_mode' => array(
            'name' => 'Тестовый режим работы модуля',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSTestMode,
            'required' => true,
        ),
        'rbspayment_two_stage' => array(
            'name' => 'Двух стадийные платежи',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSTwoStage,
            'required' => true,
        ),
        'rbspayment_send_order' => array(
            'name' => 'Передавать данные корзины покупателя в платежный шлюз для формирования чека',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSSendOrder,
            'required' => true,
        ),
        'rbspayment_tax_system' => array(
            'name' => 'Система налогообложения',
            'tip' => 'Укажите систему налогообложения (в случае предачи данных корзины покупателя)',
            'type' => $typeSelect,
            'guide_id' => $idRBSTaxSystem,
            'required' => true,
        ),
        'rbspayment_payment_methodType' => array(
            'name' => 'Признак способа расчёта',
            'tip' => 'Укажите признак способа расчёта (в случае предачи данных корзины покупателя)',
            'type' => $typeSelect,
            'guide_id' => $idRBSPaymentMethod,
            'required' => true,
        ),
        'rbspayment_payment_objectType' => array(
            'name' => 'Признак предмета расчёта',
            'tip' => 'Укажите признак предмета расчёта (в случае предачи данных корзины покупателя)',
            'type' => $typeSelect,
            'guide_id' => $idRBSPaymentObject,
            'required' => true,
        ),
        'rbspayment_payment_logging' => array(
            'name' => 'Вести логирование запросов в шлюз',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSLogging,
            'required' => true,
        ),
    );

    foreach ($fields as $code => $arField) {
        $fieldId = $fieldsCollection->addField($code, $arField['name'], $arField['type']);
        $field = $fieldsCollection->getField($fieldId);

        $isRequired = isset($arField['required']) ? $arField['required'] : false;
        if (isset($arField['guide_id'])) {
            $field->setGuideId($arField['guide_id']);
        }
        $field->setIsRequired($isRequired);
        $field->setIsInSearch(false);
        $field->setIsInFilter(false);
        $field->commit();

        $group->attachField($fieldId);
    }

// Создаем внутренний объект
    $internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
    $internalObject = $objectsCollection->getObject($internalObjectId);
    $internalObject->setValue('class_name', $className); // имя класса для реализации

// связываем его с типом
    $internalObject->setValue('payment_type_id', $typeId);
    $internalObject->setValue('payment_type_guid', 'emarket-payment-' . $typeId);
    $internalObject->commit();

// Связываем внешний тип и внутренний объект
    $objectType = $objectTypesCollection->getType($typeId);
    $objectType->setGUID($internalObject->getValue('payment_type_guid'));
    $objectType->commit();

    echo 'Установка модуля успешно завершена. id #' . $typeId;
} else {
    echo 'Способ оплаты с классом ' . $className . ' уже существует';
}

unlink(__FILE__);